world
	turf = /turf/grassLow

mob
	icon = 'mob.dmi'
	verb/say(msg as text)
		world << "<b>[usr]</b>: [html_encode(msg)]"

client/New()
	world << "<b>[src] has logged in</b>"
	..()

client/Del()
	world << "<b>[src] has logged out</b>"
	del(mob)
	..()

atom
	var/elevation = 0
	Enter(atom/movable/A)
		if(istype(A, /qturf))
			return ..()
		else if(A.elevation == elevation || A.elevation == elevation+1 || A.elevation == elevation-1)
			return ..()
		else
			return 0

	Entered(atom/movable/A)
		if(!istype(A, /qturf))
			A.elevation = elevation
			A.layer = layer+1
		..()

turf
	icon = 'turf.dmi'
	grassLow
		icon_state = "grassLow"
		elevation = 0
		layer = 2
	grassMed
		icon_state = "grassMed"
		elevation = 1
		layer = 3
	grassHigh
		icon_state = "grassHigh"
		elevation = 2
		layer = 4
	water
		icon_state = "water"
		density = 1
		elevation = 0
		layer = 2

qturf
	icon = 'qturf.dmi'
	platformHigh
		animate_movement = SYNC_STEPS
		icon_state = "platformHigh"
		elevation = 3
		layer = 5
		movingplatform
			var/distance = 3
			var/steps = 0
			proc/stepCycle()
				while(src)
					while(steps < distance)
						steps++
						step(src, dir)
						sleep(10)
					steps = 0
					dir = turn(dir, 180)
					sleep(10)
			New()
				spawn() stepCycle()
				..()

	platformLow
		icon_state = "platformLow"
		elevation = 1
		layer = 3
		movingplatform
			var/distance = 3
			var/steps = 0
			proc/stepCycle()
				while(src)
					while(steps < distance)
						steps++
						step(src, dir)
						sleep(10)
					steps = 0
					dir = turn(dir, 180)
					sleep(10)
			New()
				spawn() stepCycle()
				..()